package de.hdm_stuttgart.mi.sd1;

import org.junit.Assert;
import org.junit.Test;

/**
 * Testing {@link Prime#isPrime(int)}.
 */
public class PrimeTest {
  /**
   * Testing 1 is not prime
   */
  @Test
  public void test_1_isNotPrime() {
    Assert.assertFalse(Prime.isPrime(1));
  }

  /**
   * Testing 1 is not prime
   */
  @Test
  public void test_2_isPrime() {
    Assert.assertTrue(Prime.isPrime(2));
  }

  /**
   * Testing for primes
   */
  @Test
  public void test_Primes() {
    Assert.assertTrue(Prime.isPrime(3));
    Assert.assertTrue(Prime.isPrime(5));
    Assert.assertTrue(Prime.isPrime(7));
    Assert.assertTrue(Prime.isPrime(11));
    Assert.assertTrue(Prime.isPrime(13));
    Assert.assertTrue(Prime.isPrime(17));
    Assert.assertTrue(Prime.isPrime(19));
    Assert.assertTrue(Prime.isPrime(23));
    Assert.assertTrue(Prime.isPrime(29));
    Assert.assertTrue(Prime.isPrime(31));
    Assert.assertTrue(Prime.isPrime(37));
    Assert.assertTrue(Prime.isPrime(41));
    Assert.assertTrue(Prime.isPrime(43));
    Assert.assertTrue(Prime.isPrime(47));
    Assert.assertTrue(Prime.isPrime(53));
    Assert.assertTrue(Prime.isPrime(59));
    Assert.assertTrue(Prime.isPrime(61));
    Assert.assertTrue(Prime.isPrime(67));
    Assert.assertTrue(Prime.isPrime(71));
    Assert.assertTrue(Prime.isPrime(73));
    Assert.assertTrue(Prime.isPrime(79));
    Assert.assertTrue(Prime.isPrime(83));
    Assert.assertTrue(Prime.isPrime(89));
    Assert.assertTrue(Prime.isPrime(97));
    Assert.assertTrue(Prime.isPrime(101));
  }

  /**
   * Testing for odd none-primes
   */
  @Test
  public void testOddNonPrimes() {
    Assert.assertFalse(Prime.isPrime(9));
    Assert.assertFalse(Prime.isPrime(15));
    Assert.assertFalse(Prime.isPrime(21));
    Assert.assertFalse(Prime.isPrime(25));
    Assert.assertFalse(Prime.isPrime(27));
    Assert.assertFalse(Prime.isPrime(33));
    Assert.assertFalse(Prime.isPrime(35));
    Assert.assertFalse(Prime.isPrime(39));
    Assert.assertFalse(Prime.isPrime(45));
    Assert.assertFalse(Prime.isPrime(49));
    Assert.assertFalse(Prime.isPrime(51));
    Assert.assertFalse(Prime.isPrime(55));
    Assert.assertFalse(Prime.isPrime(57));
    Assert.assertFalse(Prime.isPrime(63));
    Assert.assertFalse(Prime.isPrime(65));
    Assert.assertFalse(Prime.isPrime(69));
    Assert.assertFalse(Prime.isPrime(75));
    Assert.assertFalse(Prime.isPrime(77));
    Assert.assertFalse(Prime.isPrime(81));
    Assert.assertFalse(Prime.isPrime(85));
    Assert.assertFalse(Prime.isPrime(87));
    Assert.assertFalse(Prime.isPrime(91));
    Assert.assertFalse(Prime.isPrime(93));
    Assert.assertFalse(Prime.isPrime(95));
    Assert.assertFalse(Prime.isPrime(99));
  }
  /**
   * Testing even none-primes
   */
  @Test
  public void testEvenNonPrimes() {
    for (int i = 2; i < 100; i++) {
      final int value = 2 * i;
      Assert.assertFalse("Testing " + value, Prime.isPrime(value));
    }
  }
}