package de.hdm_stuttgart.mi.sda1;

import de.hdm_stuttgart.mi.sda1.model.StudyCourse;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.Query;

/**
 * Read a {@link StudyCourse} by its primary key value.
 */
public class JpqlReadAllStudyCourseRecords {

  static private final EntityManagerFactory factory = Persistence.createEntityManagerFactory(
    "strategy_none");

  static private final EntityManager entityManager = factory.createEntityManager();
  /**
   * @param args unused
   */
  public static void main( String[] args ) {
    final Query queryRecords = entityManager.createQuery(
      "SELECT S.fullName, S.shortName FROM StudyCourse AS S");

    queryRecords.getResultList().stream().
      map(r -> {
        final Object[] record = (Object[]) r;
        return record[0] + " (" + record[1] + ")";
      }).
      forEach(System.out::println);

    factory.close();
  }
}