package de.hdm_stuttgart.mi.sd1.employeecompany;

import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.List;

import org.jdom2.Document;
import org.jdom2.Element;
import org.jdom2.JDOMException;
import org.jdom2.input.SAXBuilder;


/**
 * A simple http://logging.apache.org/log4j/2.x demo,
 *  see file log4j2.xml for configuration options.
 * 
 */
public class Xml2Rdbms {

   static Connection conn = null;
   
   /**
     * @param args Unused
     * @throws IOException 
     * @throws JDOMException 
     * @throws SQLException 
     */
    public static void main( String[] args ) throws JDOMException, IOException, SQLException {
       connect();
       
       final SAXBuilder builder = new SAXBuilder();
       
       final Document doc = builder.build("src/main/resources/employees.xml");
       final Element top = doc.getRootElement();
       
       processCompanys(top.getChildren());
       
       conn.close();
    }
    
    static void connect() throws SQLException {
       conn = DriverManager.getConnection("jdbc:mysql://localhost:3306/hdm", "hdmuser", "XYZ");
    }
    static void disConnect() throws SQLException {
       conn.close();
    }
    
    static void processCompanys(final List<Element> companies) throws SQLException {
       
       try (final PreparedStatement insert = conn.prepareStatement(
             "INSERT INTO Company VALUES(?, ?, ?)")) {
          final int                      ID_IDX = 1,
                                            NAME_IDX = 2,
                                               CATEGORY_IDX = 3;
          
          for (int i = 0; i < companies.size(); i++) {
             
             final int companyId = i + 1;
             
             final Element company = companies.get(i);
             insert.setInt(ID_IDX, companyId);
             insert.setString(NAME_IDX, company.getChildText("name"));
             insert.setString(CATEGORY_IDX, company.getChildText("category"));
             
             insert.executeUpdate();
             
             processEmployees(companyId, company.getChild("employees").getChildren());
          }
       }
    }
    
    static void processEmployees(final int companyId, final List<Element> employees) throws SQLException {
       try (final PreparedStatement insert = conn.prepareStatement(
             "INSERT INTO Employee VALUES(?, ?, ?, ?)")) {
          final int                       ID_IDX = 1,
                                             COMPANY_IDX = 2,
                                                COMMONNAME_IDX = 3,
                                                   EMAIL_IDX = 4;
          
          for (final Element e: employees) {
             insert.setInt(ID_IDX, Integer.parseInt(e.getAttributeValue("id")));
             insert.setInt(COMPANY_IDX, companyId);
             insert.setString(COMMONNAME_IDX, e.getChildText("commonName"));
             insert.setString(EMAIL_IDX, e.getChildText("email"));
             
             insert.executeUpdate();
          }
       }
    }
    
}
