package de.hdm_stuttgart.sw1.klausur.test;

import org.junit.Assert;
import org.junit.Test;
import org.junit.FixMethodOrder;
import org.junit.runners.MethodSorters;

import org.junit.Rule;
import org.junit.rules.DisableOnDebug;
import org.junit.rules.TestRule;
import org.junit.rules.Timeout;

import de.hdm_stuttgart.mi.exam.Marking;
import de.hdm_stuttgart.mi.exam.MarkingTest;
import de.hdm_stuttgart.sw1.klausur.string.StringHelper;

@SuppressWarnings({"static-method", "javadoc"})
@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class TestAnzahlZiffernString  extends MarkingTest {

   @Rule // Kill test if lasting longer than 1000 milliseconds unless in debugging mode
   public final TestRule timeout = new DisableOnDebug(Timeout.millis(1000));
    
   private static void pruefeErwarteteZiffernAnzahl(final String s, final int erwarteteZiffernanzahl) {
	Assert.assertEquals(
           "String '" + s + "' enthält " + erwarteteZiffernanzahl + " Ziffern",
           erwarteteZiffernanzahl,
           StringHelper.anzahlZiffern(s));
	}
	
   @Test
   public void anzahlZiffernNull() {
      Assert.assertEquals("Ein null String enthält 0 Ziffern",
            0, StringHelper.anzahlZiffern((String)null));
   }
   
   @Test
   @Marking(points=5)
   public void anzahlZiffernDiverse() {
	   
	   pruefeErwarteteZiffernAnzahl("", 0);
	   pruefeErwarteteZiffernAnzahl("Tim", 0);
	   pruefeErwarteteZiffernAnzahl(" ", 0);
	   pruefeErwarteteZiffernAnzahl("1hulgigzgzu", 1);
	   pruefeErwarteteZiffernAnzahl("wsefresd2", 1);
	   pruefeErwarteteZiffernAnzahl("0123456789", 10);
	   pruefeErwarteteZiffernAnzahl("vdfgd123jhztf", 3);
	   pruefeErwarteteZiffernAnzahl("1a2b3", 3);
	   pruefeErwarteteZiffernAnzahl("dsfcd1234frsfe", 4);
   }
}
