package de.hdm_stuttgart.sw1.klausur;

import java.util.Arrays;

public class Spielen {


	/**
	 * Bestimme alle Spieler der nächsten Runde zusammen mit ihrem jeweiligen Punktestand.
	 * 
	 * @param aktuelleRunde Die Punkte aller Teilnehmer der aktuellen Runde.  
	 * @return Die Punktestände aller Teilnehmer, welche mindestens so viele Punkte haben,
	 * wie ihr(e) Nachbar(n) oder null, falls null == aktuelleRunde. Gibt es nur einen Teilnehmer,
	 * so wird dieser zurückgeliefert.
	 */
	public static int[] getTeilnehmerNaechsteRunde(final int [] aktuelleRunde) {

		if (null == aktuelleRunde) {
			return null;
		} else {
			final int anzahlTeilnehmer = aktuelleRunde.length;
			switch(anzahlTeilnehmer) {
			case 0: return aktuelleRunde;
			default:

				int indexTeilnehmerNaechsteRunde = 0;
				// Vermutlich zu groß, es sei denn, alle Teilnehmer kommen
				// in die nächste Runde.
				final int[] teilnehmerNaechsteRunde = new int[aktuelleRunde.length];
				for (int i = 0; i < anzahlTeilnehmer; i++) {
					final int punkte = aktuelleRunde[i];
					if(
							aktuelleRunde[getLinkenNachbarn(i, anzahlTeilnehmer)] <= punkte
							&& aktuelleRunde[getRechtenNachbarn(i, anzahlTeilnehmer)] <= punkte){
						teilnehmerNaechsteRunde[indexTeilnehmerNaechsteRunde++] = punkte;
					}
				}
				// Reduziere auf tatsächliche Größe. Verzicht auf Arrays.copyOf
				// möglich durch separate Schleife.
				return Arrays.copyOf(teilnehmerNaechsteRunde, indexTeilnehmerNaechsteRunde);
			}
		}
	}

	static int getLinkenNachbarn(final int index, final int anzahlTeilnehmer) {
		if (0 == index) {
			return anzahlTeilnehmer - 1;
		} else {
			return index - 1;
		}
	}

	static int getRechtenNachbarn(final int index, final int anzahlTeilnehmer) {

		if (index == anzahlTeilnehmer - 1) {
			return 0;
		} else {
			return index + 1;
		}
	}
}
