package sax.mixed;

import java.io.IOException;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;

/** Parser, content- and errorhandler assembly */
public class MixedCount {
  /** @throws SAXException
   *  @throws ParserConfigurationException */
  public MixedCount()
   throws SAXException, ParserConfigurationException{
      final SAXParserFactory saxPf = SAXParserFactory.newInstance();
      final SAXParser saxParser = saxPf.newSAXParser();
      xmlReader = saxParser.getXMLReader();
      xmlReader.setContentHandler(eventHandler);
      xmlReader.setErrorHandler(errorHandler);
  }
  /** @see sax.stat.v1.ElementCount
   * @param uri
   * @throws IOException
   * @throws SAXException */
  public void parse(final String uri) 
    throws IOException, SAXException{
    xmlReader.parse(uri);
  }
  /** @return @see sax.stat.v1.ElementCount#getElementCount() */
  public int getCommonAuthorValueCount() {
    return eventHandler.getCommonAuthorValueCount();
  }
  private final XMLReader xmlReader;
  private final AuthorFindHandler eventHandler = new AuthorFindHandler();
  private final MyErrorHandler errorHandler = new MyErrorHandler();
}