<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    xmlns="http://www.w3.org/1999/xhtml"
    exclude-result-prefixes="xs"
    version="2.0">
    
    <xsl:output method="xhtml" indent="yes" />
    
    <xsl:template match="/letter">
        
        <html >
            <head>
                <title>
                    <xsl:text>Content: </xsl:text>
                    <xsl:value-of select="about"/>
                </title>
            </head>
            <body>
                
                
                <xsl:apply-templates select="address[@display='true' or company]"/>
                
                <dl>
                    <dt>Date:</dt>
                    <dd>
                        <b>
                            <xsl:value-of select="date"/>
                        </b>
                    </dd>
                    <dt>From:</dt>
                    <dd>
                        <b>
                            <xsl:value-of select="signature"/>
                        </b>
                    </dd>
                    <dt>Content:</dt>
                    <dd>
                        <b>
                            <xsl:value-of select="about"/>
                        </b>
                    </dd>
                </dl>
                
                <xsl:apply-templates select="paragraph|complimentaryClose|signature"/>
                
            </body>
        </html>
    </xsl:template>
    
    <xsl:template match="address">
        <address>
            <xsl:for-each select="*">
                <xsl:value-of select="."/>
                <br/>
            </xsl:for-each>

        </address>
    </xsl:template>
        
    <xsl:template match="signature">
        <p style="text-align: center;"><b>
            <xsl:value-of select="."/>
        </b></p>
    </xsl:template>
    
    <xsl:template match="paragraph|complimentaryClose">
        <p><xsl:apply-templates select="text()|*"/></p>
    </xsl:template>
    
    <xsl:template match="emphasis">
        <em style="color:red;">
            <xsl:value-of select="."/>
        </em>
    </xsl:template>

    <xsl:template match="component">
        <em style="color:red;">
            <xsl:value-of select="."/>
        </em>
    </xsl:template>
    
</xsl:stylesheet>