package de.hdm_stuttgart.mi.sda1.scripts;

import java.io.IOException;
import java.sql.SQLException;
import java.util.Hashtable;
import java.util.List;
import java.util.Map;

import org.jdom2.Document;
import org.jdom2.Element;
import org.jdom2.JDOMException;
import org.jdom2.input.SAXBuilder;

public class Transform {
	private final SAXBuilder builder = new SAXBuilder();

	private Map<String, Long> primarykeyByLanguage = new Hashtable<String, Long>();
	public Transform() {

	}

	public void xml2rdbms(final String uri) throws JDOMException, IOException, SQLException {

		final DbHandler dbHandler = new DbHandler();

		
		final Document docInput = builder.build(uri);
		final Element top = docInput.getRootElement();

		final Element 
		languages = top.getChild("languages"),
		scripts = top.getChild("scripts");

		for (final Element language: languages.getChildren()) {
			final String languageValue = language.getText();
			final Long generatedId = dbHandler.addLanguage(languageValue);
			System.out.println(generatedId + ":" + languageValue);
			primarykeyByLanguage.put(languageValue, generatedId);
		}
		for (final Element script: scripts.getChildren()) {
			final String
			xmlId = script.getAttributeValue("id")
			,descriptionValue = script.getChildText("description")
			,sourcecodeValue = script.getChildText("sourcecode");
			System.out.println(xmlId);
			
			final Long[] langArray;//= new Long[scriptLanguages.size()];
			final Element singleLanguage = script.getChild("language");
			if (null == singleLanguage) {
				final List<Element> scriptLanguages = script.getChild("languages").getChildren("language");
				langArray = new Long[scriptLanguages.size()];
				for (int i = 0; i < scriptLanguages.size(); i++) {
					langArray[i] = primarykeyByLanguage.get(scriptLanguages.get(i).getText());
				}
			} else {
				langArray = new Long[]{primarykeyByLanguage.get(singleLanguage.getText())};
			}
			dbHandler.addScript(xmlId, descriptionValue, sourcecodeValue, langArray);
		}
	}
}
