package de.hdm_stuttgart.mi.sda1.exam.jpaexport;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import de.hdm_stuttgart.mi.sda1.exam.dataexport.model.Department;

/**
 * Exporting company data. Execution requires importing corresponding
 * schema and optionally sample data from Sql/sample.sql
 */
public class EmployeeInfo {
   
   /**
    * This refers to a corresponding element {@code <persistence-unit name = "strategy_none" >} 
    * in META-INF/persistence.xml leaving the Database "as is".
    */
   static private final String PERSISTENCE_UNIT_NONE = "strategy_none";
   /**
    * @param args Unused
    */
   public static void main( String[] args ) {

      final EntityManagerFactory factory = Persistence.createEntityManagerFactory(PERSISTENCE_UNIT_NONE);
      final EntityManager em = factory.createEntityManager();
      
      // TODO: You may change the following code to search for employees first.
      
      // Selecting all departments
      final CriteriaBuilder cb = em.getCriteriaBuilder();
      final CriteriaQuery<Department> cq = cb.createQuery(Department.class);
      cq.from(Department.class); // Set query root, don't forget me!

      em.getTransaction().begin();
         for (final Department d: em.createQuery(cq).getResultList()) {
            System.out.println(d.getName());
         }
      em.getTransaction().commit();

      em.close();
      factory.close(); 
   }
}
