package de.hdm_stuttgart.mi.sda1.exam.dataexport.model;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;

/**
 * Representing a company's employees.
 */
@Entity
public class Employee {
   
   @Id
   @Column(nullable=false)
   String ssn;

   /**
    * @return A person's social security number.
    */
   public String getSsn() {
      return ssn;
   }

   /**
    * @param ssn see {@link #getSsn()}}
    */
   public void setSsn(String ssn) {
      this.ssn = ssn;
   }

   @Column(nullable=false)
   String commonName;
   /**
    * @return A person's common name e.g. Jane Smith.
    */
   public String getCommonName() {
      return commonName;
   }
   /**
    * @param commonName see {@link #getCommonName()}
    */
   public void setCommonName(String commonName) {
      this.commonName = commonName;
   }
   @ManyToOne
   @JoinColumn(name="department") // Prevent JPA from choosing "department_short"
   Department department;
   /**
    * @return An Employee's department.
    */
   public Department getDepartment() {
      return department;
   }

   /**
    * @param department see {@link #getDepartment()}
    */
   public void setDepartment(Department department) {
      this.department = department;
   }
}