package papier.klausur;

import java.io.IOException;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.jdom2.Element;
import org.jdom2.output.Format;
import org.jdom2.output.XMLOutputter;


/**
 * A simple http://logging.apache.org/log4j/2.x demo,
 *  see file log4j2.xml for configuration options.
 * 
 */
public class App {
   private static Logger log = LogManager.getLogger(App.class);

   /**
    * @param args Unused
    * @throws IOException 
    */
   public static void main( String[] args ) throws IOException {
      final Element top = new Element("top");

      final Element address = insertHelper(top, "address");
      insertHelper(address, "street", "Vanguard road");
      insertHelper(address, "town", "Mill City");

      new XMLOutputter(Format.getPrettyFormat()).output(top, System.out);
   }
   static Element insertHelper (final Element parent, String name) {
      Element child = new Element(name);
      parent.addContent(child);
      return child;
   }
   static Element insertHelper (final Element parent, String name, String content) {
      Element child = new Element(name);
      child.addContent(content);
      parent.addContent(child);
      return child;
   }
}
