package de.hdm_stuttgart.mi.sd1.address;

import de.hdm_stuttgart.mi.sd1.address.security.Authenticator;
import javafx.geometry.Insets;
import javafx.geometry.Pos;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.PasswordField;
import javafx.scene.layout.GridPane;

public class LoginScene extends Scene {

	final Main parent;

	public LoginScene(final Main parent) {
		super(parent.root);
		this.parent = parent;

		final GridPane loginPane = new GridPane();
		loginPane.setAlignment(Pos.CENTER);
		loginPane.setHgap(10);
		loginPane.setVgap(10);
		loginPane.setPadding(new Insets(25, 25, 25, 25));

		final Label enterPwLabel = new Label("Bitte Passwort eingeben:");
		final PasswordField masterPw = new PasswordField();
		
		loginPane.add(enterPwLabel, 0, 0);
		loginPane.add(masterPw, 0, 1);

		final Button cancel = new Button ("cancel");
		cancel.setOnAction(event -> System.exit(0));
		loginPane.add(cancel, 0, 2);
		
		final Button oK = new Button ("oK");
		oK.setDefaultButton(true);
		oK.setOnAction(event -> {
			if (Authenticator.validate(masterPw.getText())) {
				parent.showAddresses();
			} else {
				System.exit(0);
			}
		});
		loginPane.add(oK, 1, 2);

		setRoot(loginPane);
	}

}
