package de.hdm_stuttgart.mi.sd1.address;


import static de.hdm_stuttgart.mi.sd1.address.model.Address.Column.FIRST_NAME;
import static de.hdm_stuttgart.mi.sd1.address.model.Address.Column.LAST_NAME;
import static de.hdm_stuttgart.mi.sd1.address.model.Address.Column.STREET;
import static de.hdm_stuttgart.mi.sd1.address.model.Address.Column.TEL;
import static de.hdm_stuttgart.mi.sd1.address.model.Address.Column.TOWN;
import static de.hdm_stuttgart.mi.sd1.address.model.Address.Column.ZIP;
import javafx.geometry.Insets;
import javafx.geometry.Pos;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.TextField;
import javafx.scene.layout.GridPane;
import de.hdm_stuttgart.mi.sd1.address.model.Address;

public class NewAddressScene extends Scene {

	final Main parent;

	final TextField firstName = new TextField()
	,lastName = new TextField()
	,street = new TextField()
	,zip = new TextField()
	,town = new TextField()
	,tel = new TextField()
	;

	
	public NewAddressScene(final Main parent) {
		super(parent.root);
		this.parent = parent;

		final GridPane addressPane = new GridPane();
		addressPane.setAlignment(Pos.CENTER);
		addressPane.setHgap(10);
		addressPane.setVgap(10);
		addressPane.setPadding(new Insets(25, 25, 25, 25));

		int rowIndex = 0;
		addressPane.add(new Label(FIRST_NAME.extern), 0, rowIndex);
		addressPane.add(firstName, 1, rowIndex++);

		addressPane.add(new Label(LAST_NAME.extern),0 , rowIndex);
		addressPane.add(lastName, 1 , rowIndex++);

		addressPane.add(new Label(STREET.extern),0 , rowIndex);
		addressPane.add(street, 1 , rowIndex++);

		addressPane.add(new Label(ZIP.extern),0 , rowIndex);
		addressPane.add(zip, 1 , rowIndex++);

		addressPane.add(new Label(TOWN.extern),0 , rowIndex);
		addressPane.add(town, 1 , rowIndex++);

		addressPane.add(new Label(TEL.extern),0 , rowIndex);
		addressPane.add(tel, 1 , rowIndex++);

		final Button cancel = new Button ("cancel");
		cancel.setOnAction(event -> System.exit(0));
		addressPane.add(cancel, 0, rowIndex);
		
		final Button oK = new Button ("oK");
		oK.setDefaultButton(true);
		oK.setOnAction(event -> {
			final Address nAdr = new Address(firstName.getText(), lastName.getText(), street.getText(), 
					Integer.parseInt(zip.getText()), town.getText(), tel.getText());
			parent.browseAddresses.addAddress(nAdr);
			parent.showAddresses();
		});
		addressPane.add(oK, 1, rowIndex++);

		setRoot(addressPane);
	}

}
