package de.hdm_stuttgart.mi.sd1.binomial;

public class PerformanceTest {

  public static void main(String[] args) {

    long recursiveTime = 0, loopTime = 0;
    
    for (int i = 0; i < 10; i++) {
      {
        final long start = System.nanoTime();
        System.out.println(Binomial.binomial(90, 6));
        final long duration = (System.nanoTime() - start);
        recursiveTime += duration;
        System.out.println("Recursive: Elapsed time:" + duration);
      }
      {
        final long start = System.nanoTime();
        System.out.println(Binomial.binomialLoop(90, 6));
        final long duration = (System.nanoTime() - start);
        loopTime += duration;
        System.out.println("Loop: Elapsed time:" + duration);
      }
      System.out.println("           End of run #" + i + " -------------------------------");
    }
    System.out.println("Aggregated loop time: " + loopTime);
    System.out.println("Aggregated recursion time: " + recursiveTime);
    System.out.println("Ratio Recursive / Loop: " + (recursiveTime / loopTime));
  }
}
