package de.hdm_stuttgart.mi.sd1.collection;

import java.util.HashSet;
import java.util.Set;

/**
 * Testing sets and lists.
 *
 */
public class InsertCoordinates {

  /**
   * @param args unused
   */
  public static void main(String[] args) {

    // Defining and testing integer coordinates
    final Coordinate 
               c12 = new Coordinate(1, 2),
               c52 = new Coordinate(5, 0),
      c12Duplicate = new Coordinate(1, 2);


    System.out.println("c12:"+ c12);
    System.out.println("c12.equals(c52):"+ c12.equals(c52));
    System.out.println("c12.equals(c12Duplicate):"+ c12.equals(c12Duplicate));
    System.out.println("c12.equals(\"dummy\"):"+ c12.equals("dummy"));

    System.out.println("c12.hashCode() and c12Duplicate.hashCode():"+ c12.hashCode() + "," + c12Duplicate.hashCode());
    
    // A Set of coordinates
    final Set<Coordinate>  points =  new HashSet<Coordinate>();

    points.add(new Coordinate(1,  2));
    points.add(new Coordinate(4,  1));
    points.add(new Coordinate(1,  2)); // Equal to first Object

    // Iterate over all inserted coordinates
    System.out.println("The set contains " + points.size() + " elements:");
    for (final Coordinate c : points) {
      System.out.println(c.toString());
    }
  }
}
