package de.hdm_stuttgart.mi.sd1.stringset;

import org.junit.Assert;
import org.junit.Test;

/**
 * Testing private set implementation
 *
 */
public class BasicTest {
  
  /**
   * Testing array initializer
   */
  @Test
  public void testArrayInit() {
    // Set should contain only two strings (no duplicate).
    final Set_String names = new MySet_String(new String[]{"Jim", "Kim", "Jim"});
    Assert.assertEquals(2, names.toArray().length);
    
    names.remove("Anna"); // Not in set
    Assert.assertTrue(names.contains("Jim"));
    Assert.assertTrue(names.contains("Kim"));
    Assert.assertEquals(2, names.toArray().length);
    Assert.assertTrue(!names.isEmpty());
    
    names.remove("Jim"); // Not in set
    Assert.assertTrue(!names.contains("Jim"));
    Assert.assertTrue(names.contains("Kim"));
    Assert.assertEquals(1, names.toArray().length);
    Assert.assertTrue(!names.isEmpty());
    
    names.remove("Jim"); // Not in set
    Assert.assertTrue(!names.contains("Jim"));
    Assert.assertTrue(names.contains("Kim"));
    Assert.assertEquals(1, names.toArray().length);
    Assert.assertTrue(!names.isEmpty());
    
    names.remove("Kim"); // Not in set
    Assert.assertTrue(!names.contains("Jim"));
    Assert.assertTrue(!names.contains("Kim"));
    Assert.assertEquals(0, names.toArray().length);
    Assert.assertTrue(names.isEmpty());
    
    
    
  }

}
