package de.hdm_stuttgart.mi.sd1.htmlformat;

/**
 * A single address record holding a representation as being
 * described in {@link AddressDataHandler#AddressDataHandler(String)}
 *
 */
public class Address {

  final String firstName, lastName, companyName,
  address, city, county, postal,
  phone1, phone2, email, web;


  /**
   * Initializing from an address string obeying the description given
   * in  {@link AddressDataHandler#AddressDataHandler(String)}.
   * 
   * @param csvRecord An input address record like
   *   <code>"Aleshia","Tomkies","Alan Co.","14 Taylor St",...</code>
   * @param lineNumber Indication the current file position in case of parsing errors.
   * @throws AddressParseError Data source is corrupt.
   */
  public Address(final String csvRecord, final int lineNumber) 
      throws AddressParseError {
    firstName = "Tim";
    lastName = "Dummy";
    companyName = "Dummy Company";
    address = "Dummy street";
    city = "DummyCity";
    county = "Dummy County";
    postal = "DummyPostal";
    phone1 = "1234567";
    phone2 = "7654321";
    email = "@dummy@dummy.com";
    web = "dummy@dummy.com";
  }
}
