package de.hdm_stuttgart.mi.sd1.htmlformat;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.PrintStream;

/**
 * Format address data as ordinary text
 *
 */
public class Address2html {

  /**
   * @param args unused
   */
  public static void main(String[] args) {
    final String addressFileName = "addresses.txt",
        addressFileHtmlName = addressFileName + ".xhtml";
    try {
      final AddressDataHandler addresses = new AddressDataHandler(addressFileName);
      final AddressFormatter htmlFormatter = new Address2htmlFormatter();
      
      final PrintStream outputStream = new PrintStream(addressFileHtmlName);
      
      addresses.printAddresses(outputStream, htmlFormatter);
      outputStream.close();
    } catch (FileNotFoundException e) {
      System.err.println("File '" + addressFileName + "' not found");
    } catch (IOException e){
      System.err.println("Unable to read from file '" + addressFileName + "'");
    } catch (AddressParseError e) {
      System.err.println("Error in file '" + addressFileHtmlName + "' at line " + e.getErrorOffset() + ":"
          + e.getMessage());
    }
  }
}