package de.hdm_stuttgart.mi.nonsense;

/**
 * A sequence generator providing values within a specified bound. This may be implemented
 * by a random number generator or by any sort of sequence generator.
 *
 */
public interface SequenceGenerator {
   /**
    * return a number X within the following range:
    * 
    *  0 &lt;= X &lt; bound
    *  
    *  Thus specifying bound=3 will return a value being either 0, 1 or 2.
    * 
    * @param bound The desired upper bound (exclusive)
    *  
    * @return A value being limited by the bound argument.
    */
   public int getNextValue(int bound);
}
