package de.hdm_stuttgart.mi.sd1;

import de.hdm_stuttgart.mi.sd1.model.Rectangle;
import de.hdm_stuttgart.mi.sd1.model.SortByArea;

import java.util.Arrays;

/**
 * Sorting an Array of Rectangles
 */

public class Lambda {

    /**
     * Main entry point.
     *
     * @param args Yet unused
     */
    public static void main(String[] args) {
        test1();
    }

    static private void test1() {
        final Rectangle[] rectangles = new Rectangle[]{
                new Rectangle(2, 3),
                new Rectangle(3, 2),
                new Rectangle(4, 5),
                new Rectangle(4, 1)};

        System.out.println("Descending by width:");
        Arrays.sort(rectangles, (x, y) -> y.width - x.width);
        for (final Rectangle r : rectangles) {
            System.out.println(r);
        }

        System.out.println("\nAscending by area:");
        Arrays.sort(rectangles, (x, y) -> x.getArea() - y.getArea());
        for (final Rectangle r : rectangles) {
            System.out.println(r + ", area = " + r.getArea());
        }
    }

}