package de.hdm_stuttgart.mi.sd1.synctest;

import java.io.File;
import java.util.HashSet;
import java.util.Set;

/**
 * Adding user supplied values 
 * 
 */
public class Synctest {

   /**
    * @param args Unused
    */

   public static void main(String[] args) {
      if (1 == args.length) {
         
         final File startDirectory = new File(args[0]);
         
         if (startDirectory.isDirectory()) {
            traverse(startDirectory);
         } else {
            System.err.println(args[0] + " is no directory");
         }
         
         
      } else {
         printUsage();
      }
      
   }
   
   static void printUsage() {
      System.err.println("Usage: Synctest <directoryPathname>");
   }
   
   static public void traverse(final File directory) {
      final Set<String> lowercaseEntries = new HashSet<>();
      
      final File[]  entries = directory.listFiles();
      for (final File f: entries) {
         final String eLower = f.getName().toLowerCase();
         if (lowercaseEntries.contains(eLower)) {
            System.out.println("path='" + directory.getAbsolutePath() + ": Duplicate component '" + f.getName() + "' when ignoring case");
         } else {
            lowercaseEntries.add(eLower);
            if (f.isDirectory()) {
               traverse(f);
            }
         }
      }
   }

}
