package de.hdm_stuttgart.mi.sd1.connectfour;

import org.junit.Assert;
import org.junit.Test;

import de.hdm_stuttgart.mi.sd1.tictactoe.Board;

/**
 * Testing draw and win situations.
 */
public class AppTest {
  @Test
  public void testDraw() {
    // Creating O|X|O
    //          -+-+-
    //          X|O|O 
    //          -+-+-  
    //          X|O|X
    
    final Board board = new Board();
    
    board.nextMove(0);
    board.nextMove(1);
    board.nextMove(2);
    board.nextMove(3);
    board.nextMove(4);
    board.nextMove(6);
    board.nextMove(5);
    board.nextMove(8);
    
    Assert.assertEquals(false, board.allMovesFinished());
    Assert.assertNull(board.evaluateWinner());
    
    board.nextMove(7);
    Assert.assertEquals(true, board.allMovesFinished());
    Assert.assertNull(board.evaluateWinner());
  }

  @Test
  public void testWinner() {
    // Creating O| |x
    //          -+-+-
    //           |O| 
    //          -+-+-  
    //          x| |O
    
    final Board board = new Board();

    board.nextMove(0);//June
    board.nextMove(2);
    board.nextMove(4);//June
    board.nextMove(5);
    
    Assert.assertEquals(false, board.allMovesFinished());
    Assert.assertNull(board.evaluateWinner());
    
    board.nextMove(8);//June
    Assert.assertEquals(false, board.allMovesFinished());
    Assert.assertEquals(Board.Player.PLAYER1, board.evaluateWinner());
  }
}
