package de.hdm_stuttgart.mi.sd1.tictactoe;

public class Helper {

    /**
     * Create a new array excluding a single index value. Example:
     *
     *   Starting from array {1, 3, 8} excluding index 2 results
     *   in {1, 3}.
     *
     * @param values Source values
     * @param excludeIndex Index to be excluded from resulting array.
     * @return The original array excluding the index in question.
     */
    static public int[] excludeIndex(final int[] values, int excludeIndex) {

        final int[] ret = new int[values.length - 1];

        System.arraycopy(
                values, 0,
                ret, 0,
                excludeIndex);
        System.arraycopy(
                values, excludeIndex + 1,
                ret, excludeIndex,
                ret.length - excludeIndex);

        return ret;
    }
}