package de.hdm_stuttgart.mi.sd1.store;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;

import org.junit.Assert;
import org.junit.Test;

import de.hdm_stuttgart.mi.sd1.wc.TextFileStatistics;

@SuppressWarnings("javadoc")
public class TestWc {

  @Test
  public void testTwoInputFiles() throws FileNotFoundException, IOException {
    
      final String model_css_filename = "Testdata/model.css", //  4 lines   5  words  41 character
          input_html_filename = "Testdata/input.html";        //  9 lines  14  words 137 character
                                                        //_________________________________________
                                                        // total 13 lines  19  words 178 character
    
      final TextFileStatistics
        model_css = new TextFileStatistics(
          new BufferedReader(new FileReader(model_css_filename)), model_css_filename),
          
        input_html = new TextFileStatistics(new BufferedReader(
              new FileReader(input_html_filename)), input_html_filename);
      
      // File Testdata/model.css
      Assert.assertEquals( 4, model_css.numLines);
      Assert.assertEquals( 5, model_css.numWords);
      Assert.assertEquals(41, model_css.numCharacters);
      
      // File Testdata/input.html
      Assert.assertEquals(  9, input_html.numLines);
      Assert.assertEquals( 14, input_html.numWords);
      Assert.assertEquals(137, input_html.numCharacters);
      
      // Grand total
      Assert.assertEquals( 13, TextFileStatistics.getTotalNumLines());
      Assert.assertEquals( 19, TextFileStatistics.getTotalNumWords());
      Assert.assertEquals(178, TextFileStatistics.getTotalNumCharacters());
  }
}
