package de.hdm_stuttgart.sd1.leap;

import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

import org.junit.Test;

/**
 * Testing leap year behaviour.
 */
public class LeapYearTest {
   /**
    * Test for leap years.
    */
   @Test
   public void testLeapYearPositive() {
      assertTrue(LeapYear.isLeapYear(2000)); // Divisible by 400.
      assertTrue(LeapYear.isLeapYear(1984)); // Divisible by 4 and indivisible by 100.
   }

   /**
    * Test for non-leap years.
    */
   @Test
   public void testLeapYearNegative() {
      assertFalse(LeapYear.isLeapYear(2001)); //Indivisible by 4.
      assertFalse(LeapYear.isLeapYear(1800)); // divisible by 100 but indivisible by 400.
   }
}