package de.hdm_stuttgart.mi.sd1.plot;

/**
 * An interface describing functions expecting and returning double values.
 * Lambda expressions may be used to pass functions
 *
 */
public interface DoubleOfDoubleFunction {
   /**
    * A function expecting a double argument and returning
    * a double value like e.g. double Math.sin(double)
    * 
    * @param x An argument
    * @return A value
    */
   public double compute(double x);
}
