package de.hdm_stuttgart.sd1.sum;

/**
 * Summing up integer values.
 *
 */
public class Summing {

  /**
   * @param args unused
   */
  public static void main(String[] args) {
    // Simple tests
    System.out.println("1 + 2 + 3" + "=" + getSum(3));
    System.out.println("1 + 2 + ... + 150" + "=" + getSum(150));


    long start = System.nanoTime();
    System.out.println("1 + 2 + ... + 65535" + "=" + getSum(65535));
    long end = System.nanoTime();
    System.out.println("Elapsed time: " + (end - start) + " nanoseconds");
  }
  
  /**
   * Summing up all integers starting from 0 up to and including a given limit
   * Example: Let the limit be 5, then the result is 1 + 2 + 3 + 4 + 5  
   * 
   * @param limit The last number to include into the computed sum
   * @return The sum of 1 + 2 + ... + limit
   */
  public static long getSum (int limit) {
    int sum = 0;
    for (int i = 1; i <= limit; i++) {
      sum += i;
    }
    return sum;
  }
}