<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    xmlns:html="http://www.w3.org/1999/xhtml"
    xmlns="http://www.w3.org/1999/xhtml"
    exclude-result-prefixes="xs html"
    version="2.0">

    <xsl:output indent="no"/>
    
    
    <!-- Default identity transformation  -->
    <xsl:template match="@*|node()">
        <xsl:copy>
            <xsl:apply-templates select="@*|node()"/>
        </xsl:copy>
    </xsl:template>
    
    
    <!-- Handling images separately -->
    <xsl:template match="html:img[@align]">
        <img>
            <!-- copy all but 'align' attributes -->
            <xsl:copy-of select="@*[name() != 'align']"/>
            <xsl:attribute name="style">
                <xsl:choose>
                    <xsl:when test="@align='top'"    >vertical-align: top;</xsl:when>
                    <xsl:when test="@align='middle'" >vertical-align: middle;</xsl:when>
                    <xsl:when test="@align='bottom'" >vertical-align: bottom;</xsl:when>

                    <xsl:when test="@align='left'"   >float: left;</xsl:when>
                    <xsl:when test="@align='right'"  >float: right;</xsl:when>
                    
                    <xsl:otherwise>
                        <xsl:message>
                            <xsl:text>No idea how to handle illegal align='</xsl:text>
                            <xsl:value-of select="@align"/>
                            <xsl:text>'.</xsl:text>
                        </xsl:message>
                    </xsl:otherwise>
                </xsl:choose>
                
            </xsl:attribute>
        </img>
        
    </xsl:template>
    
</xsl:stylesheet>