package de.hdm_stuttgart.mi.company.model;

import java.util.HashSet;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.UniqueConstraint;

@Entity
@Table(
		uniqueConstraints= {@UniqueConstraint(columnNames={"name"})}
)
@SuppressWarnings("javadoc")
public class Project {

	protected Project(){}
	
   public Project(final String name){
		this.name = name;
	}
	
	@Id
	@GeneratedValue
	Long id;
	
	String name;
	
	@OneToMany(mappedBy="project", cascade=CascadeType.ALL)
	Set<WorksFor> employees = new HashSet<WorksFor>();

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public Set<WorksFor> getEmployees() {
		return employees;
	}

	public void setEmployees(Set<WorksFor> employees) {
		this.employees = employees;
	}

	public Long getId() {
		return id;
	}
	
	
	
}
