package de.hdm_stuttgart.mi.persistence.test;

import de.hdm_stuttgart.mi.persistence.PersistView;

/**
 * Mimic a GUI frontend.
 *
 */
public class ViewMockup implements PersistView {

   boolean connected = false,
         dataInserted = false;
   
   String error, info;
   
   @Override
   public void setStatusConnected() {
      connected = true;      
   }

   @Override
   public void setStatusDisconnected() {
      connected = false;
   }

   /**
    * Clear for subsequent unit test(s).
    */
   public void clearDataInserted() {
      dataInserted = false;
   }
   
   @Override
   public void setDatasetInserted() {
      dataInserted = true;
   }

   @Override
   public void guiInfo(String msg) {
      info = msg;
      
   }

   @Override
   public void guiError(String msg) {
      error = msg;
   }
}
