
DROP TABLE IF EXISTS Flight;
DROP TABLE IF EXISTS Destination;
DROP TABLE IF EXISTS Airline;

CREATE Table Airline (
   id INT NOT NULL
  ,name CHAR(20) NOT NULL
  ,airlineCode CHAR(5) NOT NULL
  
  ,CONSTRAINT _PK_Airline_id PRIMARY KEY(id)
  ,CONSTRAINT _UN_Airline_name UNIQUE(name)
  ,CONSTRAINT _UN_Airline_airlineCode UNIQUE(airlineCode)
);

CREATE TABLE Destination (
   id INT NOT NULL
  ,fullName CHAR(20) NOT NULL
  ,airportCode CHAR(5)
    
  ,CONSTRAINT _PK_Destination_id PRIMARY KEY(id)
  ,CONSTRAINT _UN_Destination_airportCode UNIQUE(airportCode)
);

CREATE TABLE Flight (
   id INT NOT NULL
  ,flightNumber CHAR(10) NOT NULL
  ,airline INT NOT NULL REFERENCES Airline
  ,origin int NOT NULL REFERENCES Destination
  ,destination int NOT NULL REFERENCES Destination

  -- For yet unknown reasons the following alternative MySQL 5.1 syntax compatible
  --   statements fail with message 'Cannot add foreign key constraint":
  --  ,CONSTRAINT _FK_Flight_airline FOREIGN KEY(airline) REFERENCES Airline
  --  ,CONSTRAINT _FK_Flight_origin FOREIGN KEY(origin) REFERENCES Destination
  --  ,CONSTRAINT _FK_Flight_destination FOREIGN KEY(destination) REFERENCES Destination
  
  ,CONSTRAINT _PK_Flight_id UNIQUE(id)
  ,CONSTRAINT _UN_Flight_flightNumber UNIQUE(flightNumber)
  ,CONSTRAINT _CK_Flight_origin_destination CHECK(NOT(origin = destination))
);
  
  
  
 