package de.hdm_stuttgart.mi.sda1.catalog2sql;

import java.io.PrintStream;
import java.util.List;

/**
 * Formatting product related INSERT statements
 *
 */
public class SqlFormatter {
	
	final PrintStream output;

	/**
	 * Writing SQL statements to standard output
	 */
	public SqlFormatter() {
		this.output = System.out;
	}
	
	/**
	 * @param output SQL output destination stream
	 */
	public SqlFormatter(final PrintStream output) {
		this.output = output;
	}
	
	/**
	 * Create an SQL INSERT statement corresponding to a &lt;product id='...' &gt; entry
	 * lacking age specification.
	 * @param productId  See {@link #insertproduct(String, String, int)}
	 * @param productName See {@link #insertproduct(String, String, int)}
	 */
	public void insertproduct(final String productId, final String productName) {
		output.println("INSERT INTO Product (id, name) VALUES ('" + productId + "', '" + productName +  "');");
	}
	/**
	 * Create an SQL INSERT statement corresponding to a &lt;product id='...' &gt; entry
	 * @param productId The product's unique id property
	 * @param productName The product's end user readable name.
	 * @param age The product's age
	 */
	public void insertproduct(final String productId, final String productName, final int age) {
		output.println("INSERT INTO Product VALUES ('" + productId + "', '" + productName +  "', " + age + ");");
	}

	
	/**
	 * Adding a description to a given product.
	 * 
	 * @param productId The description belongs to this product 
	 * @param descriptions All descriptions belonging to productId
	 */
	public void insertDescription(final String productId, final List<String> descriptions) {
		for (int i = 0; i < descriptions.size(); i++) {
			output.println("INSERT INTO Description VALUES('" + productId + "', " + i + ", '" + descriptions.get(i) + "');");
		}
		output.println("-- end of current product entry --\n");
	}
	
}
