package de.hdm_stuttgart.mi.sda1.xmlstatistics;

import java.io.IOException;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.junit.Assert;
import org.junit.Test;
import org.xml.sax.SAXException;
import org.xml.sax.SAXNotRecognizedException;
import org.xml.sax.SAXNotSupportedException;
import org.xml.sax.XMLReader;

import de.hdm_stuttgart.mi.sda1.saxerrorhandler.handler.SaxErrorHandler;
import de.hdm_stuttgart.mi.sda1.xmlstatistics.handler.SaxContentHandler;

/**
 * Unit test for simple App.
 */
public class AppTest {
    /**
     * Dummy test method
     * @throws SAXException 
     * @throws ParserConfigurationException 
     * @throws IOException 
     */
    @Test
    public void testNamespaceSet() throws ParserConfigurationException, SAXException, IOException {
    	final SAXParserFactory saxPf = SAXParserFactory.newInstance();
    	
        final SAXParser saxParser = saxPf.newSAXParser();
        final XMLReader xmlReader = saxParser.getXMLReader();
        
        xmlReader.setFeature("http://xml.org/sax/features/validation", false);
        xmlReader.setFeature("http://xml.org/sax/features/namespaces", true);
        xmlReader.setFeature("http://xml.org/sax/features/namespace-prefixes", true);
        
        final SaxContentHandler contentHandler = new SaxContentHandler();
        xmlReader.setContentHandler(contentHandler); 
        xmlReader.setErrorHandler(new SaxErrorHandler());
        
        final String xmlDocumentInstanceFilename = "sample.xsl";
        xmlReader.parse(xmlDocumentInstanceFilename);
        
        Assert.assertArrayEquals(new String[]{"http://www.w3.org/1999/xhtml","http://www.w3.org/1999/XSL/Transform"},
        		contentHandler.getNamespaces());
    }
    
    // Further tests not yet written for lazyness ...
}
