package de.hdm_stuttgart.mi.sda2.jpa.cd;

import java.io.File;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.EntityTransaction;
import javax.persistence.Persistence;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Unmarshaller;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import de.hdm_stuttgart.mi.sda2.jpa.cd.domain.Catalog;
import de.hdm_stuttgart.mi.sda2.jpa.cd.domain.Cd;


/**
 * A simple http://logging.apache.org/log4j/2.x demo,
 *  see file log4j2.xml for configuration options.
 * 
 */
public class Driver {
    private static Logger log = LogManager.getLogger(Driver.class);

    /**
     * @param args Unused
     * @throws JAXBException 
     */
    public static void main( String[] args ) throws JAXBException {
    	
        final JAXBContext cdContext = JAXBContext.newInstance("de.hdm_stuttgart.mi.sda2.jpa.cd.domain");
        final Unmarshaller u = cdContext.createUnmarshaller();
        final Catalog catalog = (Catalog) u.unmarshal(new File("cdData.xml"));
        
        
        
        for (final Cd cd : catalog.getCd()) {
        	log.debug("CD:" + cd.getArtist());
        }
        toDatabase(catalog);
    }
    
    private static void toDatabase(final Catalog catalog) {
		EntityManagerFactory factory = Persistence.createEntityManagerFactory("persistenceUnit");
		EntityManager manager = factory.createEntityManager();

		EntityTransaction tx = manager.getTransaction();
		tx.begin();
		try {
	    	for (final Cd cd : catalog.getCd()) {
	    		manager.persist(cd);
	        }
		} catch (Exception e) {
			e.printStackTrace();
		}
		tx.commit();
    	
    }
    
}
