package de.hdm_stuttgart.mi.sda2.jpa.cd.domain;

import static javax.persistence.CascadeType.PERSIST;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.UniqueConstraint;

@Entity 
@Table(name = "StudentLecture", uniqueConstraints=@UniqueConstraint(columnNames={"student", "lecture"}))
public class StudentLecture {

   @Id @GeneratedValue(strategy=GenerationType.IDENTITY)
   Long id;
   
   @ManyToOne(cascade={PERSIST})
   @JoinColumn(name="student", nullable=false)
   Student student;
   
   @ManyToOne(cascade={PERSIST})
   @JoinColumn(name="lecture", nullable=false)
   Lecture lecture;

   @Column(nullable=false)
   int workload;
   
   protected StudentLecture() {}
   
   public StudentLecture(final Student student, final Lecture lecture, int workload) {
      setStudent(student);
      student.getLectures().add(this);
      
      setLecture(lecture);
      lecture.getStudents().add(this);
      setWorkload(workload);
   }

   public Long getId() {
      return id;
   }

   public Student getStudent() {
      return student;
   }

   public void setStudent(Student student) {
      this.student = student;
   }

   public Lecture getLecture() {
      return lecture;
   }

   public void setLecture(Lecture lecture) {
      this.lecture = lecture;
   }

   public int getWorkload() {
      return workload;
   }

   public void setWorkload(int workload) {
      this.workload = workload;
   }
}


