package de.hdm_stuttgart.mi.sda2.bibimport;

import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.Reader;
import java.util.Map;
import java.util.Map.Entry;

import org.jbibtex.BibTeXDatabase;
import org.jbibtex.BibTeXEntry;
import org.jbibtex.BibTeXParser;
import org.jbibtex.Key;
import org.jbibtex.ParseException;
import org.jbibtex.TokenMgrException;
import org.jbibtex.Value;

public class ParseBib {

   public static void main( String[] args ) throws TokenMgrException, ParseException, FileNotFoundException {
      
      Reader read = new FileReader("Testdata/gecco00.bib");
      
       BibTeXParser parser = new BibTeXParser();
       
       BibTeXDatabase database = parser.parse(read);
       
       final Map<Key, BibTeXEntry> entries = database.getEntries();
       
       System.out.println("Found " + entries.size() + " entries.");
       
       for (Entry<Key, BibTeXEntry> entry : entries.entrySet() ) {
          System.out.println("key:" + entry.getKey());
          
          Map<Key, Value> fields = entry.getValue().getFields();
          
          for (Entry<Key, Value> field : fields.entrySet()) {
             System.out.println(field.getKey() + ":" + field.getValue());
          }
          
          System.out.println("----------------------");
          
       }
       
   }

}
