package de.hdm_stuttgart.mi.sda2.forum.domain;

import java.io.Serializable;
import java.util.List;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

@Entity
public class User implements Serializable {

	private static final long serialVersionUID = -7123471572071976042L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

	@NotNull
	@Column(nullable=false)
	@Size(min=1, max=40)
	String name;
	
	@NotNull
	@Column(unique=true, nullable=false)
	@Size(min=1, max=40)
	String email;
	
	@NotNull
	@Column(nullable=false)
	@Size(min=1)
	String password;
	
	@OneToMany(mappedBy="user")
	List<Subscription> subscriptions; 
	
	public User() {}
	
	public User(final String name, final String email, final String pasword) {
		setName(name);
		setEmail(email);
		setPassword(pasword);
	}
	
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }
	
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}

	public String getEmail() {
		return email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	public String getPassword() {
		return password;
	}

	public void setPassword(String password) {
		this.password = password;
	}
}
