<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="2.0"
  xmlns:xlink="http://www.w3.org/1999/xlink"
  xmlns="http://docbook.org/ns/docbook" xmlns:db="http://docbook.org/ns/docbook">
  
  <xsl:output indent="no"/>
  
  <xsl:template match="@* | node()">
    <xsl:copy>
      <xsl:apply-templates select="node()| @*"/>
    </xsl:copy>
  </xsl:template>
  
  <xsl:template match="db:imagedata[ends-with(@fileref, '.fig')]">    
    <xsl:copy>
      <xsl:attribute name="fileref">
        <xsl:value-of select="@fileref"/>
        <xsl:text>.svg</xsl:text>
      </xsl:attribute>
      <xsl:apply-templates select="@*[not(name(.) = 'fileref')] | node()"/>
    </xsl:copy>
  </xsl:template>
  
  <xsl:template match="db:imagedata[ends-with(@fileref, '.pdf')]">    
    <xsl:copy>
      <xsl:attribute name="fileref">
        <xsl:value-of select="@fileref"/>
        <xsl:text>.svg</xsl:text>
      </xsl:attribute>
      <xsl:apply-templates select="@*[not(name(.) = 'fileref')] | node()"/>
    </xsl:copy>
  </xsl:template>
  
  <xsl:template match="db:figure/db:mediaobject/db:imageobject/db:imagedata[ends-with(@fileref, '.svg')]">
    
    <xsl:copy>
      <xsl:attribute name="scale">
        <xsl:text>150</xsl:text>
      </xsl:attribute>
      <xsl:apply-templates select="@*[not(name(.) = 'scale')] | node()"/>
    </xsl:copy>
    
  </xsl:template>
  
</xsl:stylesheet>
