<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:fo="http://www.w3.org/1999/XSL/Format" 
    xmlns:kk="http://www.hdm-stuttgart.de/xmleditor/schema/kkabrechnung"
    >
    
    <xsl:key name="verordnungByBerechtigter" match="/kk:abrechnung/kk:verordnungen/kk:verordnung" use="@ref" />
    <xsl:key name="unfallById" match="/kk:abrechnung/kk:unfaelle/kk:unfall" use="@id" />
    <xsl:key name="berechtigterZuId" match="/kk:abrechnung/kk:berechtigte/*" use="@id" />
    
    <xsl:template name="behandlungsart">
        <xsl:param name="typ"/>
        <xsl:choose>
            <xsl:when test="$typ='rezept'">Rezept</xsl:when>
            <xsl:when test="$typ='ambulant'">Ambulant</xsl:when>
            <xsl:when test="$typ='zahn'">Zahn</xsl:when>
            <xsl:when test="$typ='heilmittel'">Heilmittel</xsl:when>
            <xsl:when test="$typ='stationaer'">Stationär</xsl:when>
            <xsl:otherwise>
                <xsl:text>Unbekannter Verordnungstyp:</xsl:text>
                <xsl:value-of select="$typ"/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    
    <!-- Unfälle -->
    <xsl:template match="kk:unfaelle">
        <xsl:if test="kk:unfall">
            <fo:block font-size="16pt" font-weight="bold">Unfallbeschreibungen</fo:block>
            <xsl:apply-templates select="kk:unfall"/>
        </xsl:if>
    </xsl:template>
    
    <xsl:template match="kk:unfall">
        <fo:block font-size="14pt" font-weight="bold">
            <xsl:apply-templates select="." mode="nr"/>
            <xsl:text>. </xsl:text>
            <xsl:value-of select="kk:title"/>
        </fo:block>
        <xsl:apply-templates select="kk:para"/>    
    </xsl:template>
    
    <xsl:template match="kk:para">
        <fo:block>
            <xsl:value-of select="."/>
        </fo:block>
    </xsl:template>
    
    <xsl:template match="kk:unfall" mode="nr">
        <xsl:text>U</xsl:text>
        <xsl:value-of select="1 +count(preceding-sibling::kk:unfall)"/>
    </xsl:template>
    
</xsl:stylesheet>
