package entity.company7;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;


import entity.company7.model.Employee;
import entity.company7.model.Project;

/**
 * Defining many-to-many relationship between
 * {@link Employee} and {@link Project}
 *
 */
public class Persist {
   public static void main(String[] args) {

      final EntityManagerFactory factory = Persistence.createEntityManagerFactory("entityCompany7PU");
      final EntityManager em = factory.createEntityManager();
      em.getTransaction().begin();
      {
         final Employee  martin = new Employee(123, "Martin Goik"),
               eve = new Employee(140, "Eve Blix"),
               jim = new Employee(160, "Jim Clarke");

         em.persist(martin);
         em.persist(eve);
         em.persist(jim);

         final Project water = new Project(1, "Water supply")
               ,health = new Project(2, "Health management");

         em.persist(water);
         em.persist(health);

         martin.addProject(water);
      }
      em.getTransaction().commit();

      em.close();
      factory.close();
   }
}