package entity.company8;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.TypedQuery;

import entity.company8.model.Employee;
import entity.company8.model.Project;

public class ReassignProjects {

   public static void main(String[] args) {

      final EntityManagerFactory factory = Persistence.createEntityManagerFactory("entityCompany8NoDropPU");
      final EntityManager em = factory.createEntityManager();
      em.getTransaction().begin();
      {
         final TypedQuery<Employee> queryEmployee = em.createQuery(
               "SELECT e FROM Employee e WHERE e.staffNumber = :staffNumber", Employee.class);

         final Employee
         martin = queryEmployee.setParameter("staffNumber", 123).getSingleResult(),
         eve = queryEmployee.setParameter("staffNumber", 140).getSingleResult(),
         jim = queryEmployee.setParameter("staffNumber", 160).getSingleResult();

         final TypedQuery<Project> queryProject = em.createQuery(
               "SELECT p FROM Project p WHERE p.no = :no", Project.class);

         final Project water = queryProject.setParameter("no", 1).getSingleResult();
         water.removeEmployee(martin);
         water.addEmployee(jim);

         em.persist(martin);
         em.persist(eve);
         em.persist(jim);
      }
      em.getTransaction().commit();

      em.close();
      factory.close();
   }
}