package entity.company8.model;

import javax.persistence.AssociationOverride;
import javax.persistence.AssociationOverrides;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Transient;

/**
 * 
 *         {@link Employee} and {@link Project} related by
 *         {@link EmployeeProject} and {@link OneToMany} / {@link ManyToOne}
 * 
 */
@Entity
@AssociationOverrides({
@AssociationOverride(name ="pk.employee", joinColumns = @JoinColumn(name ="employee_id")),
@AssociationOverride(name ="pk.project", joinColumns = @JoinColumn(name ="project_id"))
        })
public class EmployeeProject {
   
   @EmbeddedId
   private EmployeeProjectPk getPk() { return pk;}
   protected void setPk(EmployeeProjectPk pk) { this.pk = pk;}
   private EmployeeProjectPk pk = new EmployeeProjectPk();
   
   @Transient
   public Employee getEmployee() { return getPk().getEmployee();}
   public void setEmployee(Employee employee) { getPk().setEmployee(employee);}

   @Transient
   public Project getProject() { return getPk().getProject();}
   public void setProject(Project project) { getPk().setProject(project);}
 
   public boolean equals(Object o) {
      if (this == o) {
         return true;
      } else if (o instanceof EmployeeProject) {
         return getPk().equals(((EmployeeProject) o).getPk());
      } else {
         return false;
      }
  }
  public int hashCode() {
     if (null == getPk()) {
        return 0;
     } else {
        return getPk().hashCode();
     }
  }
}
