package hibintro.v1;

import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.Query;

/**
 * Retrieval all {@link User} attributes from a database.
 *
 */
public class GetUsersAsAttributes {

   /**
    * Retrieving a single {@link User} instance by means
    * of its primary key value "goik".
    * @param args unused
    */
   public static void main(String[] args) {
      final EntityManagerFactory factory = Persistence.createEntityManagerFactory("hibintroV1PU");
      final EntityManager em = factory.createEntityManager();

      em.getTransaction().begin();
      {
         final Query queryUidCname = em.createQuery("select uid, cname from User");

         @SuppressWarnings("unchecked")
         final List<Object> usersAttributes = queryUidCname.getResultList();

         System.out.println("queryResult type:" + usersAttributes.get(0).getClass().getSimpleName());
         for (final Object o: usersAttributes) {
            System.out.println("result set element type:" + o.getClass().getSimpleName());
            final Object attributes[] = (Object []) o;
            for (Object attribute: attributes) {
               System.out.println("attribute value:" + attribute);
            }
         }
      }
      em.getTransaction().commit();

      em.close();
      factory.close();
   }
}