package hibintro.v1;

import javax.persistence.Entity;
import javax.persistence.Id;

/**
 * A simple class intended to be mapped to a database server
 *
 */
@Entity
public class User {

  String uid;
  /**
   * @return  The user's unique login name e.g. "goik"
   */
  @Id
  public String getUid() {
    return uid;
  }
  /**
   * @param uid See {@link #getUid()}.
   */
  public void setUid(String uid) {
    this.uid = uid;
  }
  String cname;
  /**
   * @return The user's common name e.g. "Martin Goik"
   */
  public String getCname() {
    return cname;
  }
  /**
   * @param cname See {@link #getCname()}.
   */
  public void setCname(String cname) {
    this.cname = cname;
  }

  /**
   * Hibernate/JPA require a default constructor. It has has to be
   * implemented if any non-default constructor has been defined
   */
  protected User() {}

  /**
   * @param uid See {@link #getUid()}.
   * @param cname See {@link #getCname()}.
   */
  public User(String uid, String cname) {
    this.uid = uid;
    this.cname = cname;
  }
}