package inherit.v1;


import java.text.ParseException;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

/**
 * Persisting a simple instance of {@link BillingDetails}
 */
public class Persist {

   /**
    * @param args not used.
    * @throws ParseException Credit card expiration may be mis-spelled.
    */
   public static void main(String[] args) throws ParseException {
      final EntityManagerFactory factory = Persistence.createEntityManagerFactory("inheritV1PU");
      final EntityManager em = factory.createEntityManager();

      em.getTransaction().begin();
      {
         em.persist(new CreditCard("4412 8334 4512 9416", 1, "05/18/15"));
         em.persist(new BankAccount("1107 2 31", "Lehman Brothers", "BARCGB22"));
      }
      em.getTransaction().commit();

      em.close();
      factory.close();
   }
}