<?xml version="1.0" encoding="UTF-8"?>
<!-- $Id: book2toc.xsl 177 2006-11-01 16:36:30Z goik $ -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  
  <!-- The doctype will show up in the generated HTML document -->
  <xsl:output
    doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN"
    doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd" 
    method="xml" indent="yes"/>
  
  <xsl:template match="/book">
    <!-- Variable to be used in HEAD/TITLE and H1 elements -->
    <xsl:variable name="pageTitle">
      <xsl:value-of select="title"/>
      <xsl:text>, Table of contents</xsl:text>
    </xsl:variable>
    <html>
      <head>
        <title><xsl:value-of select="$pageTitle"/></title>
      </head>
      <body>
        <h1><xsl:value-of select="$pageTitle"/></h1>
        <ul>
          <xsl:for-each select="chapter">
            <li><xsl:value-of select="title"/></li>
          </xsl:for-each>
        </ul>
      </body>
    </html>
  </xsl:template>
</xsl:stylesheet>