<?xml version="1.0" encoding="ISO-8859-1"?> 
<!-- $Id: memo2html.xsl 148 2006-03-17 13:57:51Z goik $ -->
<xsl:stylesheet version="2.0" xmlns:xsl=
    "http://www.w3.org/1999/XSL/Transform"
    xmlns:xs="http://www.w3.org/2001/XMLSchema">

  <xsl:output method="html" indent="yes"/>

  <xsl:template match="/">
    <xsl:apply-templates select="memo"/>
  </xsl:template>

  <xsl:template match="memo">
    <html>
      <title>
        <xsl:text>Short message from: </xsl:text>
        <xsl:value-of select="from/name"/>
        <xsl:text> </xsl:text>
        <xsl:value-of select="from/surname"/>
        <xsl:text>, </xsl:text>
        <xsl:value-of select='format-date(date, "[D].[M].[Y]")'/>
      </title>
      <body>
        <h1>
          <xsl:text>Short message from: </xsl:text>
          <xsl:value-of select="from/name"/>
          <xsl:text> </xsl:text>
          <xsl:value-of select="from/surname"/>
        </h1>
        <p>To:</p>
        
        <ul>
          <xsl:for-each select="to">
            <li>
              <xsl:apply-templates select="."/>
            </li>
          </xsl:for-each>
        </ul>
        <p>
          <xsl:text>Date: </xsl:text> 
          <b>
            <xsl:value-of select='format-date(date, "[D].[M].[Y]")'/>
          </b>
        </p>
        <p>
          <b>Subject:<xsl:value-of select="subject"/></b>
          <xsl:apply-templates select="content"/>
        </p>
      </body>
    </html>
  </xsl:template>

  <xsl:template match="from|to">
    <xsl:value-of select="name"/>
    <xsl:text> </xsl:text>
    <b>
      <xsl:value-of select="surname"/>
    </b>
  </xsl:template>
  
  <xsl:template match="content">
    <xsl:for-each select="para">
      <p><xsl:value-of select="."/></p>
    </xsl:for-each>
  </xsl:template>
  
</xsl:stylesheet>
