package sax.count;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.XMLReader;

import sax.stat.v2.MyErrorHandler;

/** Driver class */
public class Driver {

  /**
   * @param argv unused
   * @throws Exception  Exception File access problem or corrupt content.
   */
  public static void main(String argv[]) throws Exception {

    final SAXParserFactory saxPf = SAXParserFactory.newInstance();
    final SAXParser saxParser = saxPf.newSAXParser();
    final XMLReader xmlReader = saxParser.getXMLReader();
    final ListTagNamesHandler handler = new ListTagNamesHandler();
    xmlReader.setContentHandler(handler);
    xmlReader.setErrorHandler(new MyErrorHandler());
    xmlReader.parse("Input/Xml/Memo/message.xml");

    System.out.print("List of elements: {");
    for (String elementName : handler.getTagNames()) {
      System.out.print(elementName + " ");
    }
    System.out.println("}");
  }
}