package sax.stat.v1;

import org.xml.sax.Attributes;
import org.xml.sax.helpers.DefaultHandler;

/**Counting number of elements in a given XML instance */
public class MyEventHandler extends DefaultHandler {

  /** Print out event's name @see DefaultHandler#startDocument()*/
  public void startDocument() {
    System.out.println("Opening Document");
  }
  /** Print out event name @see DefaultHandler#endDocument() */
  public void endDocument() {
    System.out.println("Closing Document");
  }
  /** @see DefaultHandler#startElement(
   * String, String, String, Attributes) */
  public void startElement(String namespaceUri, String localName,
      String rawName, Attributes attrs) {
    System.out.println("Opening \"" + rawName + "\"");
    elementCount++;
  }
  /** @see DefaultHandler#endElement(String, String, String) */
  public void endElement(String namespaceUri, String localName,
      String rawName) {
    System.out.println("Closing \"" + rawName + "\"");
  }
  /** pure copy input to result,
   * @see DefaultHandler#characters(char[], int, int) */
  public void characters(char[] ch, int start, int length) {
    System.out.println("Content \"" + new String(ch, start, length)
        + '"');
  }
  /** @return Number of @see Element nodes in given document */
  public int getElementCount() {
    return elementCount;
  }
  private int elementCount = 0;
}