package party;

abstract class PartyStatisticsAverageImpl implements PartyStatistics {

    @Override
    public void setNumberOfGuests(int numGuests) { this.numGuests = numGuests;}

    @Override
    public void setNumberOfOrganizers(int numOrganizers) { this.numOrganizers = numOrganizers;}

    @Override
    public void setExpenses(float expenses) { this.expenses = expenses;}

    @Override
    public float getAverageExpenses() throws NoOrganizerException {
        if (0 < numOrganizers) {
            return expenses / numOrganizers;
        } else {
            throw new NoOrganizerException(expenses);
        }
    }
    
    protected int numGuests = 0;
    protected int numOrganizers = 0;
    protected float expenses = 0f;
}
