package xml2rdbms;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

/**
 * Providing element content information for arbitrary XML input documents.
 *
 */
public class BillingHandler extends DefaultHandler {
	
	String currentElement;

	@Override
	public void startElement(String uri, String localName, String qName,
			Attributes attributes) throws SAXException {
		currentElement = qName;
		
	}

	@Override
	public void characters(char[] ch, int start, int length)
			throws SAXException {
		final String content = new String(ch, start, length);
		if (0 < content.trim().length()) {
			System.out.println("Current element '" + currentElement
			+ "' contains text value '" + content + "'");
		}
 	}

}
